diff --git a/doc/api/doxy-api-index.md b/doc/api/doxy-api-index.md
index 7a91001..0540aba 100644
--- a/doc/api/doxy-api-index.md
+++ b/doc/api/doxy-api-index.md
@@ -45,7 +45,6 @@ There are many libraries, so their headers may be grouped by topics:
   [vhost]              (@ref rte_virtio_net.h),
   [KNI]                (@ref rte_kni.h),
   [PCI]                (@ref rte_pci.h),
-  [PCI IDs]            (@ref rte_pci_dev_ids.h)
 
 - **memory**:
   [memseg]             (@ref rte_memory.h),
diff --git a/doc/guides/prog_guide/dev_kit_build_system.rst b/doc/guides/prog_guide/dev_kit_build_system.rst
index bbb9ea0..6b89af6 100644
--- a/doc/guides/prog_guide/dev_kit_build_system.rst
+++ b/doc/guides/prog_guide/dev_kit_build_system.rst
@@ -89,44 +89,43 @@ Each build directory contains include files, libraries, and applications:
 
 
     ~/DEV/DPDK$ ls i686-native-linuxapp-gcc/include/
-    cmdline_cirbuf.h           rte_eal_memconfig.h         rte_per_lcore.h
-    cmdline.h                  rte_errno.h                 rte_pipeline.h
-    cmdline_parse_etheraddr.h  rte_eth_af_packet.h         rte_port_ethdev.h
-    cmdline_parse.h            rte_eth_bond_8023ad.h       rte_port_frag.h
-    cmdline_parse_ipaddr.h     rte_eth_bond.h              rte_port.h
-    cmdline_parse_num.h        rte_eth_ctrl.h              rte_port_ras.h
-    cmdline_parse_portlist.h   rte_ethdev.h                rte_port_ring.h
-    cmdline_parse_string.h     rte_ether.h                 rte_port_sched.h
-    cmdline_rdline.h           rte_eth_ring.h              rte_port_source_sink.h
-    cmdline_socket.h           rte_fbk_hash.h              rte_power.h
-    cmdline_vt100.h            rte_hash_crc.h              rte_prefetch.h
-    exec-env                   rte_hash.h                  rte_random.h
-    generic                    rte_hexdump.h               rte_red.h
-    rte_acl.h                  rte_icmp.h                  rte_reorder.h
-    rte_acl_osdep.h            rte_interrupts.h            rte_ring.h
-    rte_alarm.h                rte_ip_frag.h               rte_rtm.h
-    rte_approx.h               rte_ip.h                    rte_rwlock.h
-    rte_arp.h                  rte_jhash.h                 rte_sched_common.h
-    rte_atomic_32.h            rte_jobstats.h              rte_sched.h
-    rte_atomic_64.h            rte_kvargs.h                rte_sctp.h
-    rte_atomic.h               rte_launch.h                rte_spinlock.h
-    rte_bitmap.h               rte_lcore.h                 rte_string_fns.h
-    rte_branch_prediction.h    rte_log.h                   rte_table_acl.h
-    rte_byteorder_32.h         rte_lpm6.h                  rte_table_array.h
-    rte_byteorder_64.h         rte_lpm.h                   rte_table.h
-    rte_byteorder.h            rte_lru.h                   rte_table_hash.h
-    rte_cfgfile.h              rte_malloc.h                rte_table_lpm.h
-    rte_common.h               rte_malloc_heap.h           rte_table_lpm_ipv6.h
-    rte_compat.h               rte_mbuf.h                  rte_table_stub.h
-    rte_config.h               rte_memcpy.h                rte_tailq.h
-    rte_cpuflags.h             rte_memory.h                rte_tcp.h
-    rte_cycles.h               rte_mempool.h               rte_thash.h
-    rte_debug.h                rte_memzone.h               rte_timer.h
-    rte_devargs.h              rte_meter.h                 rte_udp.h
-    rte_dev.h                  rte_pci_dev_feature_defs.h  rte_vect.h
-    rte_dev_info.h             rte_pci_dev_features.h      rte_version.h
-    rte_distributor.h          rte_pci_dev_ids.h           rte_virtio_net.h
-    rte_eal.h                  rte_pci.h
+    cmdline_cirbuf.h           rte_eal.h                   rte_port_ethdev.h
+    cmdline.h                  rte_eal_memconfig.h         rte_port_frag.h
+    cmdline_parse_etheraddr.h  rte_errno.h                 rte_port.h
+    cmdline_parse.h            rte_eth_af_packet.h         rte_port_ras.h
+    cmdline_parse_ipaddr.h     rte_eth_ctrl.h              rte_port_ring.h
+    cmdline_parse_num.h        rte_ethdev.h                rte_port_sched.h
+    cmdline_parse_portlist.h   rte_ether.h                 rte_port_source_sink.h
+    cmdline_parse_string.h     rte_fbk_hash.h              rte_power.h
+    cmdline_rdline.h           rte_hash_crc.h              rte_prefetch.h
+    cmdline_socket.h           rte_hash.h                  rte_random.h
+    cmdline_vt100.h            rte_hexdump.h               rte_red.h
+    exec-env                   rte_icmp.h                  rte_reorder.h
+    generic                    rte_interrupts.h            rte_ring.h
+    rte_acl.h                  rte_ip_frag.h               rte_rtm.h
+    rte_acl_osdep.h            rte_ip.h                    rte_rwlock.h
+    rte_alarm.h                rte_jhash.h                 rte_sched_common.h
+    rte_approx.h               rte_jobstats.h              rte_sched.h
+    rte_arp.h                  rte_kvargs.h                rte_sctp.h
+    rte_atomic_32.h            rte_launch.h                rte_spinlock.h
+    rte_atomic_64.h            rte_lcore.h                 rte_string_fns.h
+    rte_atomic.h               rte_log.h                   rte_table_acl.h
+    rte_bitmap.h               rte_lpm6.h                  rte_table_array.h
+    rte_branch_prediction.h    rte_lpm.h                   rte_table.h
+    rte_byteorder_32.h         rte_lru.h                   rte_table_hash.h
+    rte_byteorder_64.h         rte_malloc.h                rte_table_lpm.h
+    rte_byteorder.h            rte_malloc_heap.h           rte_table_lpm_ipv6.h
+    rte_cfgfile.h              rte_mbuf.h                  rte_table_stub.h
+    rte_common.h               rte_memcpy.h                rte_tailq.h
+    rte_compat.h               rte_memory.h                rte_tcp.h
+    rte_config.h               rte_mempool.h               rte_thash.h
+    rte_cpuflags.h             rte_memzone.h               rte_timer.h
+    rte_cycles.h               rte_meter.h                 rte_udp.h
+    rte_debug.h                rte_pci_dev_feature_defs.h  rte_vect.h
+    rte_devargs.h              rte_pci_dev_features.h      rte_version.h
+    rte_dev.h                  rte_pci.h                   rte_virtio_net.h
+    rte_dev_info.h             rte_per_lcore.h
+    rte_distributor.h          rte_pipeline.h
 
 
 A build directory is specific to a configuration that includes architecture + execution environment + toolchain.
diff --git a/lib/librte_eal/common/Makefile b/lib/librte_eal/common/Makefile
index f5ea0ee..bb9810d 100644
--- a/lib/librte_eal/common/Makefile
+++ b/lib/librte_eal/common/Makefile
@@ -34,7 +34,7 @@ include $(RTE_SDK)/mk/rte.vars.mk
 INC := rte_branch_prediction.h rte_common.h
 INC += rte_debug.h rte_eal.h rte_errno.h rte_launch.h rte_lcore.h
 INC += rte_log.h rte_memory.h rte_memzone.h rte_pci.h
-INC += rte_pci_dev_ids.h rte_per_lcore.h rte_random.h
+INC += rte_per_lcore.h rte_random.h
 INC += rte_tailq.h rte_interrupts.h rte_alarm.h
 INC += rte_string_fns.h rte_version.h
 INC += rte_eal_memconfig.h rte_malloc_heap.h
diff --git a/lib/librte_eal/common/include/rte_pci_dev_ids.h b/lib/librte_eal/common/include/rte_pci_dev_ids.h
deleted file mode 100644
index 6720b7a..0000000
--- a/lib/librte_eal/common/include/rte_pci_dev_ids.h
+++ /dev/null
@@ -1,93 +0,0 @@
-/*-
- * This file is provided under a dual BSD/GPLv2 license.  When using or
- *   redistributing this file, you may do so under either license.
- *
- *   GPL LICENSE SUMMARY
- *
- *   Copyright(c) 2010-2015 Intel Corporation. All rights reserved.
- *
- *   This program is free software; you can redistribute it and/or modify
- *   it under the terms of version 2 of the GNU General Public License as
- *   published by the Free Software Foundation.
- *
- *   This program is distributed in the hope that it will be useful, but
- *   WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- *   General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
- *   The full GNU General Public License is included in this distribution
- *   in the file called LICENSE.GPL.
- *
- *   Contact Information:
- *   Intel Corporation
- *
- *   BSD LICENSE
- *
- *   Copyright(c) 2010-2014 Intel Corporation. All rights reserved.
- *   All rights reserved.
- *
- *   Redistribution and use in source and binary forms, with or without
- *   modification, are permitted provided that the following conditions
- *   are met:
- *
- *     * Redistributions of source code must retain the above copyright
- *       notice, this list of conditions and the following disclaimer.
- *     * Redistributions in binary form must reproduce the above copyright
- *       notice, this list of conditions and the following disclaimer in
- *       the documentation and/or other materials provided with the
- *       distribution.
- *     * Neither the name of Intel Corporation nor the names of its
- *       contributors may be used to endorse or promote products derived
- *       from this software without specific prior written permission.
- *
- *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
- *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
- *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
- *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
- *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
- *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- *
- */
-
-/**
- * @file
- *
- * This file contains a list of the PCI device IDs recognised by DPDK, which
- * can be used to fill out an array of structures describing the devices.
- *
- * Currently four families of devices are recognised: those supported by the
- * IGB driver, by EM driver, those supported by the IXGBE driver, and by virtio
- * driver which is a para virtualization driver running in guest virtual machine.
- * The inclusion of these in an array built using this file depends on the
- * definition of
- * at the time when this file is included.
- *
- * In order to populate an array, the user of this file must define this macro:
- * RTE_PCI_DEV_ID_DECL_IXGBE(vendorID, deviceID). For example:
- *
- * @code
- * struct device {
- *     int vend;
- *     int dev;
- * };
- *
- * struct device devices[] = {
- * #define RTE_PCI_DEV_ID_DECL_IXGBE(vendorID, deviceID) {vend, dev},
- * #include <rte_pci_dev_ids.h>
- * };
- * @endcode
- *
- * Note that this file can be included multiple times within the same file.
- */
-
-/*
- * Undef all RTE_PCI_DEV_ID_DECL_* here.
- */